Package org.eclipse.rdf4j.rio.n3

## Class N3Writer

- java.lang.Object
- - org.eclipse.rdf4j.rio.n3.N3Writer

- All Implemented Interfaces:
    `CharSink`, `Sink`, `RDFHandler`, `RDFWriter`

      public class N3Writer
      extends Object
      implements RDFWriter, CharSink

  An implementation of the RDFWriter interface that writes RDF documents in N3 format. Note: the current implementation simply wraps a `TurtleWriter` and writes documents in Turtle format, which is a subset of N3.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `N3Writer​(OutputStream out)` | Creates a new N3Writer that will write to the supplied OutputStream.
    `N3Writer​(OutputStream out, ParsedIRI baseIRI)` | Creates a new N3Writer that will write to the supplied OutputStream.
    `N3Writer​(Writer writer)` | Creates a new N3Writer that will write to the supplied Writer.
    `N3Writer​(Writer writer, ParsedIRI baseIRI)` | Creates a new N3Writer that will write to the supplied Writer.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `endRDF()` | Signals the end of the RDF data.
    `FileFormat` | `getFileFormat()` | Get the `FileFormat` this sink uses.
    `RDFFormat` | `getRDFFormat()` | Gets the RDF format that this RDFWriter uses.
    `Collection<RioSetting<?>>` | `getSupportedSettings()` |
    `Writer` | `getWriter()` | get the `Writer` used by this `CharSink`.
    `WriterConfig` | `getWriterConfig()` | Retrieves the current writer configuration as a single object.
    `void` | `handleComment​(String comment)` | Handles a comment.
    `void` | `handleNamespace​(String prefix, String name)` | Handles a namespace declaration/definition.
    `void` | `handleStatement​(Statement st)` | Handles a statement.
    `<T> RDFWriter` | `set​(RioSetting<T> setting, T value)` | Set a setting on the writer, and return this writer object to allow chaining.
    `RDFWriter` | `setWriterConfig​(WriterConfig config)` | Sets all supplied writer configuration options.
    `void` | `startRDF()` | Signals the start of the RDF data.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.common.io.Sink

      `acceptsFileFormat`

- - ### Constructor Detail

    - #### N3Writer

          public N3Writer​(OutputStream out)

      Creates a new N3Writer that will write to the supplied OutputStream.
      Parameters:
        `out` - The OutputStream to write the N3 document to.

    - #### N3Writer

          public N3Writer​(OutputStream out,
                          ParsedIRI baseIRI)

      Creates a new N3Writer that will write to the supplied OutputStream.
      Parameters:
        `out` - The OutputStream to write the N3 document to.
        `baseIRI` - used to relativize IRIs to relative IRIs.

    - #### N3Writer

          public N3Writer​(Writer writer)

      Creates a new N3Writer that will write to the supplied Writer.
      Parameters:
        `writer` - The Writer to write the N3 document to.

    - #### N3Writer

          public N3Writer​(Writer writer,
                          ParsedIRI baseIRI)

      Creates a new N3Writer that will write to the supplied Writer.
      Parameters:
        `writer` - The Writer to write the N3 document to.
        `baseIRI` - used to relativize IRIs to relative IRIs.

  - ### Method Detail

    - #### getWriter

          public Writer getWriter()

      Description copied from interface: `CharSink`
      get the `Writer` used by this `CharSink`.
      Specified by:
        `getWriter` in interface `CharSink`
      Returns:
        an `Writer`

    - #### getRDFFormat

          public RDFFormat getRDFFormat()

      Description copied from interface: `RDFWriter`
      Gets the RDF format that this RDFWriter uses.
      Specified by:
        `getRDFFormat` in interface `RDFWriter`

    - #### setWriterConfig

          public RDFWriter setWriterConfig​(WriterConfig config)

      Description copied from interface: `RDFWriter`
      Sets all supplied writer configuration options.
      Specified by:
        `setWriterConfig` in interface `RDFWriter`
      Parameters:
        `config` - a writer configuration object.
      Returns:
        Either a copy of this writer, if it is immutable, or this object, to allow chaining of method calls.

    - #### getWriterConfig

          public WriterConfig getWriterConfig()

      Description copied from interface: `RDFWriter`
      Retrieves the current writer configuration as a single object.
      Specified by:
        `getWriterConfig` in interface `RDFWriter`
      Returns:
        a writer configuration object representing the current configuration of the writer.

    - #### getSupportedSettings

          public Collection<RioSetting<?>> getSupportedSettings()

      Specified by:
        `getSupportedSettings` in interface `RDFWriter`
      Returns:
        A collection of `RioSetting`s that are supported by this RDFWriter.

    - #### set

          public <T> RDFWriter set​(RioSetting<T> setting,
                                   T value)

      Description copied from interface: `RDFWriter`
      Set a setting on the writer, and return this writer object to allow chaining.
      Specified by:
        `set` in interface `RDFWriter`
      Parameters:
        `setting` - The setting to change.
        `value` - The value to change.
      Returns:
        Either a copy of this writer, if it is immutable, or this object, to allow chaining of method calls.

    - #### startRDF

          public void startRDF()
                        throws RDFHandlerException

      Description copied from interface: `RDFHandler`
      Signals the start of the RDF data. This method is called before any data is reported.
      Specified by:
        `startRDF` in interface `RDFHandler`
      Throws:
        `RDFHandlerException` - If the RDF handler has encountered an unrecoverable error.

    - #### endRDF

          public void endRDF()
                      throws RDFHandlerException

      Description copied from interface: `RDFHandler`
      Signals the end of the RDF data. This method is called when all data has been reported.
      Specified by:
        `endRDF` in interface `RDFHandler`
      Throws:
        `RDFHandlerException` - If the RDF handler has encountered an unrecoverable error.

    - #### handleNamespace

          public void handleNamespace​(String prefix,
                                      String name)
                               throws RDFHandlerException

      Description copied from interface: `RDFHandler`
      Handles a namespace declaration/definition. A namespace declaration associates a (short) prefix string with the namespace's URI. The prefix for default namespaces, which do not have an associated prefix, are represented as empty strings.
      Specified by:
        `handleNamespace` in interface `RDFHandler`
      Parameters:
        `prefix` - The prefix for the namespace, or an empty string in case of a default namespace.
        `name` - The URI that the prefix maps to.
      Throws:
        `RDFHandlerException` - If the RDF handler has encountered an unrecoverable error.

    - #### handleStatement

          public void handleStatement​(Statement st)
                               throws RDFHandlerException

      Description copied from interface: `RDFHandler`
      Handles a statement.
      Specified by:
        `handleStatement` in interface `RDFHandler`
      Parameters:
        `st` - The statement.
      Throws:
        `RDFHandlerException` - If the RDF handler has encountered an unrecoverable error.

    - #### handleComment

          public void handleComment​(String comment)
                             throws RDFHandlerException

      Description copied from interface: `RDFHandler`
      Handles a comment.
      Specified by:
        `handleComment` in interface `RDFHandler`
      Parameters:
        `comment` - The comment.
      Throws:
        `RDFHandlerException` - If the RDF handler has encountered an unrecoverable error.

    - #### getFileFormat

          public FileFormat getFileFormat()

      Description copied from interface: `Sink`
      Get the `FileFormat` this sink uses.
      Specified by:
        `getFileFormat` in interface `Sink`
      Returns:
        a `FileFormat`. May not be `null`.